
  <!DOCTYPE html>
  <html>
    <head>
      <title>useSubmit.ts</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/pages/additional-confirugation/hooks/useSubmit.ts</td><td class="">89.39%</td><td class="">80%</td><td class="">132</td><td class="">118</td><td class="">14</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import { Feed } from &#x27;../../../api/feed&#x27;;
import { useFeeds } from &#x27;./useFeeds&#x27;;
import { useCallback } from &#x27;react&#x27;;
import { useUpdateFeeds } from &#x27;../../../queries/feeds&#x27;;
import { useParams } from &#x27;react-router-dom&#x27;;
import { useUpdateFitParameters } from &#x27;../../../queries/projectSettings&#x27;;
import {
  FitParameter,
  mapOutputRoleToInputRole,
  mapOutputTypeToInputType
} from &#x27;../../../api/projectSettings&#x27;;
import { useInputs } from &#x27;./useInputs&#x27;;

export const useSubmit = (values: any) =&gt; {
  const { projectId } = useParams&lt;{ projectId: string }&gt;();
  const feeds = useFeeds();
  const inputs = useInputs();
  const { mutateAsync: mutateAsyncUpdateFeeds } = useUpdateFeeds();
  const { mutateAsync: mutateAsyncUpdateFitParameters } =
    useUpdateFitParameters();

  return useCallback(() =&gt; {
    const updateFeeds: (Feed &amp; { id: string })[] = [];
    const updateFitParameters: (Partial&lt;FitParameter&gt; &amp; { id: string })[] = [];
    Object.keys(values).forEach((key) =&gt; {
      console.log(&#x27;&gt;&gt;&gt; key:&#x27;, key);
      if (key.includes(&#x27;___feed&#x27;)) {
        const value = values[key];
        const [id] = key.split(&#x27;___&#x27;);
        const currentFeed = feeds.find((f) =&gt; f.id === id);
        if (currentFeed) {
          updateFeeds.push({
            ...currentFeed,
            value,
            id
          });
        }
      } else if (key.includes(&#x27;___input&#x27;)) {
        const [id] = key.split(&#x27;___&#x27;);
        if (!updateFitParameters.find((p) =&gt; p.id === id)) {
          const oldFitParameter = inputs.find((inp) =&gt; inp.id === id);
          if (oldFitParameter) {
            const target = values[`${oldFitParameter.id}___input___target`];
            const lower_bound = values[`${oldFitParameter.id}___input___low`];
            const upper_bound = values[`${oldFitParameter.id}___input___high`];
            updateFitParameters.push({
              id: oldFitParameter.id,
              name: oldFitParameter.name,
              role: (mapOutputRoleToInputRole as any)[
                oldFitParameter.role as any
              ],
              type: (mapOutputTypeToInputType as any)[
                oldFitParameter.type as any
              ],
              upper_bound,
              lower_bound,
              target
            });
          }
        }
      }
    });
    return Promise.all([
      mutateAsyncUpdateFeeds({
        projectId,
        feeds: updateFeeds
      }),
      mutateAsyncUpdateFitParameters({
        projectId,
        fitParameters: updateFitParameters
      })
    ]);
  }, [
    feeds,
    inputs,
    mutateAsyncUpdateFeeds,
    mutateAsyncUpdateFitParameters,
    projectId,
    values
  ]);
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:13,&quot;character&quot;:26,&quot;text&quot;:&quot;values&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:27,&quot;character&quot;:14,&quot;text&quot;:&quot;value&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:27,&quot;character&quot;:22,&quot;text&quot;:&quot;values&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:42,&quot;character&quot;:18,&quot;text&quot;:&quot;target&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:42,&quot;character&quot;:27,&quot;text&quot;:&quot;values&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:43,&quot;character&quot;:18,&quot;text&quot;:&quot;lower_bound&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:43,&quot;character&quot;:32,&quot;text&quot;:&quot;values&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:44,&quot;character&quot;:18,&quot;text&quot;:&quot;upper_bound&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:44,&quot;character&quot;:32,&quot;text&quot;:&quot;values&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:48,&quot;character&quot;:21,&quot;text&quot;:&quot;mapOutputRoleToInputRole as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:49,&quot;character&quot;:16,&quot;text&quot;:&quot;oldFitParameter.role as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:51,&quot;character&quot;:21,&quot;text&quot;:&quot;mapOutputTypeToInputType as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:52,&quot;character&quot;:16,&quot;text&quot;:&quot;oldFitParameter.type as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/additional-confirugation/hooks/useSubmit.ts&quot;,&quot;line&quot;:78,&quot;character&quot;:4,&quot;text&quot;:&quot;values&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  